<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑' : '添加'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="闸机名称" name="gateName">
        <a-input
          allow-clear
          placeholder="请输入闸机名称"
          v-model:value="form.gateName"
        />
      </a-form-item>
      <a-form-item label="闸机被使用的展馆" name="siteId">
        <a-input
          allow-clear
          placeholder="请输入闸机被使用的展馆"
          v-model:value="form.siteId"
        />
      </a-form-item>
      <a-form-item label="闸机编码" name="gateCode">
        <a-input
          allow-clear
          placeholder="请输入闸机编码"
          v-model:value="form.gateCode"
        />
      </a-form-item>
      <a-form-item label="闸机序列码" name="gateMac">
        <a-input
          allow-clear
          placeholder="请输入闸机序列码"
          v-model:value="form.gateMac"
        />
      </a-form-item>
      <a-form-item label="闸机 IP" name="gateIp">
        <a-input
          allow-clear
          placeholder="请输入闸机 IP"
          v-model:value="form.gateIp"
        />
      </a-form-item>
      <a-form-item label="闸机状态(1=正常 2=模块异常)" name="gateState">
        <a-input
          allow-clear
          placeholder="请输入闸机状态(1=正常 2=模块异常)"
          v-model:value="form.gateState"
        />
      </a-form-item>
      <a-form-item label="闸机通心跳次数" name="liveNumber">
        <a-input
          allow-clear
          placeholder="请输入闸机通心跳次数"
          v-model:value="form.liveNumber"
        />
      </a-form-item>
      <a-form-item label="创建时间" name="crateTime">
        <a-input
          allow-clear
          placeholder="请输入创建时间"
          v-model:value="form.crateTime"
        />
      </a-form-item>
      <a-form-item label="创建人id" name="createUser">
        <a-input
          allow-clear
          placeholder="请输入创建人id"
          v-model:value="form.createUser"
        />
      </a-form-item>
      <a-form-item label="更新次数" name="updateNumber">
        <a-input
          allow-clear
          placeholder="请输入更新次数"
          v-model:value="form.updateNumber"
        />
      </a-form-item>
      <a-form-item label="最近更新时间，作为系统设计预留字段" name="updateTime">
        <a-input
          allow-clear
          placeholder="请输入最近更新时间，作为系统设计预留字段"
          v-model:value="form.updateTime"
        />
      </a-form-item>
      <a-form-item label="最近更新数据id 系统设计使用" name="updateUser">
        <a-input
          allow-clear
          placeholder="请输入最近更新数据id 系统设计使用"
          v-model:value="form.updateUser"
        />
      </a-form-item>
      <a-form-item label="数据逻辑删除状态 0:未删除 1 ：已删除； 物理删除不用考虑该字段 作为系统设计预留字段" name="deleteStatus">
        <a-input
          allow-clear
          placeholder="请输入数据逻辑删除状态 0:未删除 1 ：已删除； 物理删除不用考虑该字段 作为系统设计预留字段"
          v-model:value="form.deleteStatus"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addThinkGate, updateThinkGate } from '@/api/think/thinkGate';
  import { ThinkGate } from '@/api/think/thinkGate/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: ThinkGate | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<ThinkGate>({
    id: undefined,
    gateName: undefined,
    siteId: undefined,
    gateCode: undefined,
    gateMac: undefined,
    gateIp: undefined,
    gateState: undefined,
    liveNumber: undefined,
    crateTime: undefined,
    createUser: undefined,
    updateNumber: undefined,
    updateTime: undefined,
    updateUser: undefined,
    deleteStatus: undefined,
    thinkGateId: undefined,
    thinkGateName: '',
    status: 0,
    comments: '',
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    thinkGateName: [
      {
        required: true,
        type: 'string',
        message: '请填写名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateThinkGate : addThinkGate;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
